Recent Posts

Pages: 1 ... 3 4 [5] 6 7 ... 10
41
Polylines / Merge polylines using SendCommand VB.NET
« Last post by fixo on April 21, 2013, 01:01:59 PM »
    Here is the basic command to merge / subtract closed contours,
   tested on A2010
VB.NET
Code: [Select]
        <CommandMethod("mep", CommandFlags.Session)> _
        Public Shared Sub testUnionPlines()
            Dim doc As Document = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument
            Dim ed As Editor = doc.Editor
            Dim db As Database = doc.Database
            ' get argument to choose boolean operation mode
            Dim pko As New PromptKeywordOptions(vbLf & "Choose boolean operation mode " & "[Union/Subtract]: ", "Union Subtract")
            ' The default depends on our current settings
            pko.Keywords.[Default] = "Union"
            Dim pkr As PromptResult = ed.GetKeywords(pko)
            If pkr.Status <> PromptStatus.OK Then
                Return
            End If
            Dim choice As String = pkr.StringResult

            Dim doUnion As Boolean = If(choice = "Union", True, False)
            Dim regLst As New List(Of Region)()
            Dim delPline As New List(Of Polyline)()
            Using doclock As DocumentLock = doc.LockDocument()
                'start a transaction
                Using tr As Transaction = db.TransactionManager.StartTransaction()

                    Dim tvs As TypedValue() = New TypedValue(2) {New TypedValue(0, "lwpolyline"), New TypedValue(-4, "&"), New TypedValue(70, 1)}
                    Dim filter As New SelectionFilter(tvs)
                    Dim pso As New PromptSelectionOptions()
                    pso.MessageForRemoval = vbLf & "Select closed polylines only: "
                    pso.MessageForAdding = vbLf & "Select closed polylines: "
                    Dim result As PromptSelectionResult = ed.GetSelection(filter)
                    If result.Status <> PromptStatus.OK Then
                        Return
                    End If

                    Try
                        Dim sset As SelectionSet = result.Value
                        Dim ids As ObjectId() = sset.GetObjectIds()
                        Dim btr As BlockTableRecord = DirectCast(tr.GetObject(db.CurrentSpaceId, OpenMode.ForWrite, False), BlockTableRecord)
                        Dim objreg1 As New Region()

                        For n As Integer = 0 To ids.Count() - 1

                            Dim obj As DBObject = TryCast(tr.GetObject(ids(n), OpenMode.ForRead), DBObject)
                            Dim pline1 As Polyline = TryCast(obj, Polyline)
                            If pline1 Is Nothing Then
                                Return
                            End If
                            ' Add the polyline to the List to rerase them all at the end of execution
                            delPline.Add(pline1)
                            ' Add the polyline to the array
                            Dim objArray1 As New DBObjectCollection()
                            objArray1.Add(pline1)
                            ' create the 1 st region
                            Dim objRegions1 As New DBObjectCollection()
                            objRegions1 = Region.CreateFromCurves(objArray1)
                            objreg1 = TryCast(objRegions1(0), Region)
                            btr.AppendEntity(objreg1)

                            tr.AddNewlyCreatedDBObject(objreg1, True)

                            objreg1.ColorIndex = 1
                            'optional
                            ' add the region to the List<Region> for the future work
                            regLst.Add(objreg1)
                        Next
                        'ed.WriteMessage("\nCount regions:\t{0}\n", regLst.Count);//just for the debug

                        ' sort regions by areas
                        Dim items As Region() = regLst.ToArray()
                        Array.Sort(items, Function(x As Region, y As Region) y.Area.CompareTo(x.Area))
                        ' get the biggest region first
                        Dim mainReg As Region = items(0)
                        ' ed.WriteMessage("\nMain region area:\t{0:f3}\n", items[0].Area);//just for the debug
                        If Not mainReg.IsWriteEnabled Then
                            mainReg.UpgradeOpen()
                        End If
                        If items.Length = 2 Then

                            If Not doUnion Then
                                mainReg.BooleanOperation(BooleanOperationType.BoolSubtract, DirectCast(items(1), Region))
                            Else
                                mainReg.BooleanOperation(BooleanOperationType.BoolUnite, DirectCast(items(1), Region))
                            End If
                        Else
                            ' starting iteration from the second region
                            Dim i As Integer = 1
                            Do
                                Dim reg1 As Region = items(i)
                                Dim reg2 As Region = items(i + 1)

                                If (reg1 Is Nothing) OrElse (reg2 Is Nothing) Then
                                    Exit Do
                                Else

                                    ' subtract region 1 from region 2
                                    If reg1.Area > reg2.Area Then
                                        ' subtract the smaller region from the larger one
                                        '
                                        reg1.BooleanOperation(BooleanOperationType.BoolUnite, reg2)
                                        If Not doUnion Then
                                            mainReg.BooleanOperation(BooleanOperationType.BoolSubtract, reg1)
                                        Else
                                            mainReg.BooleanOperation(BooleanOperationType.BoolUnite, reg1)

                                        End If
                                    Else


                                        ' subtract the smaller region from the larger one

                                        reg2.BooleanOperation(BooleanOperationType.BoolUnite, reg1)
                                        If Not doUnion Then
                                            mainReg.BooleanOperation(BooleanOperationType.BoolSubtract, reg2)
                                        Else
                                            mainReg.BooleanOperation(BooleanOperationType.BoolUnite, reg2)
                                        End If

                                    End If
                                End If
                                ' increase counter
                                i += 1
                            Loop While i < items.Length - 1
                        End If
                        mainReg.ColorIndex = 1
                        ' put dummy color for region
                        ' erase polylines
                        For Each poly As Polyline In delPline
                            If poly IsNot Nothing Then
                                If Not poly.IsWriteEnabled Then
                                    poly.UpgradeOpen()
                                End If
                                poly.Erase()
                                If Not poly.IsDisposed Then
                                    poly.Dispose()
                                End If
                            End If
                        Next

                        '  ---    explode region and create polyline from exploded entities   ---   //

                        Dim regexpl As New DBObjectCollection()
                        mainReg.Explode(regexpl)

                        Dim exids As New List(Of ObjectId)()

                        ' gather selected object into the List<ObjectId>
                        If regexpl.Count > 0 Then
                            For Each obj As DBObject In regexpl
                                Dim ent As Entity = TryCast(obj, Entity)
                                If ent IsNot Nothing Then
                                    Dim eid As ObjectId = btr.AppendEntity(ent)
                                    tr.AddNewlyCreatedDBObject(ent, True)
                                   
                                    exids.Add(eid)
                                End If
                            Next
                        End If
                        ' define AcadDocument as object
                        Dim ActiveDocument As Object = doc.AcadDocument
                        Dim entids As ObjectId() = New ObjectId() {}
                        Array.Resize(entids, exids.Count)
                        ' convert List<ObjectId> to array of ObjectID
                        exids.CopyTo(entids, 0)

                        ed.Regen()
                        ' create a new selection set and exploded items
                        Dim newset As SelectionSet = SelectionSet.FromObjectIds(entids)

                        ed.SetImpliedSelection(newset.GetObjectIds())

                        Dim pfres As PromptSelectionResult = ed.SelectImplied()
                        ' execute Sendcommand synchronously
                        ActiveDocument.GetType().InvokeMember("SendCommand", System.Reflection.BindingFlags.InvokeMethod, Nothing, ActiveDocument, New Object() {"select" & vbLf})
                        ' execute Sendcommand synchronously
                        Dim cmd As String = "_pedit _M _P" & " " & "" & " " & "_J" & " " & "" & " " & "" & vbLf
                        ActiveDocument.GetType().InvokeMember("SendCommand", System.Reflection.BindingFlags.InvokeMethod, Nothing, ActiveDocument, New Object() {cmd})
                        ' rerase region if this is do not erased (relative to current DELOBJ variable value)
                        If mainReg IsNot Nothing Then
                            If Not mainReg.IsWriteEnabled Then
                                mainReg.UpgradeOpen()
                            End If
                        End If
                        mainReg.Erase()
                       
                        tr.Commit()

                    Catch ex As Autodesk.AutoCAD.Runtime.Exception

                        ed.WriteMessage((vbLf & "AutoCAD exception:" & vbLf + ex.Message & vbLf) + ex.StackTrace)
                    Finally
                        'optional, might be removed
                        ed.WriteMessage(vbLf & "{0}", New Autodesk.AutoCAD.Runtime.ErrorStatus().ToString())
                    End Try
                End Using
            End Using
        End Sub
42
Polylines / Merge polylines using SendCommand C#
« Last post by fixo on April 21, 2013, 01:00:30 PM »
   Here is the basic command to merge / subtract closed contours,
   tested on A2010   
C#
 
Code: [Select]
    [CommandMethod("Rea", CommandFlags.Session)]
        public static void testForUnionPlines()
        {
            Document doc = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument;
            Editor ed = doc.Editor;
            Database db = doc.Database;
            // get argument to choose boolean operation mode
            PromptKeywordOptions pko = new PromptKeywordOptions("\nChoose boolean operation mode " + "[Union/Subtract]: ", "Union Subtract");
            // The default depends on our current settings
            pko.Keywords.Default = "Union";
            PromptResult pkr = ed.GetKeywords(pko);
            if (pkr.Status != PromptStatus.OK) return;
            string choice = pkr.StringResult;

            bool doUnion = choice == "Union" ? true : false;
            List<Region> regLst = new List<Region>();
            List<Polyline> delPline = new List<Polyline>();
            using (DocumentLock doclock = doc.LockDocument())
            {
                //start a transaction
                using (Transaction tr = db.TransactionManager.StartTransaction())
                {

                    TypedValue[] tvs = new TypedValue[3]
            {new TypedValue(0, "lwpolyline"),
                new TypedValue(-4, "&"),
                new TypedValue(70, 1)
            };
                    SelectionFilter filter = new SelectionFilter(tvs);
                    PromptSelectionOptions pso = new PromptSelectionOptions();
                    pso.MessageForRemoval = "\nSelect closed polylines only: ";
                    pso.MessageForAdding = "\nSelect closed polylines: ";
                    PromptSelectionResult result = ed.GetSelection(filter);
                    if (result.Status != PromptStatus.OK) return;

                    try
                    {
                        SelectionSet sset = result.Value;
                        ObjectId[] ids = sset.GetObjectIds();
                        BlockTableRecord btr = (BlockTableRecord)tr.GetObject(db.CurrentSpaceId, OpenMode.ForWrite, false);
                        Region objreg1 = new Region();

                        for (int n = 0; n < ids.Count(); n++)
                        {

                            DBObject obj = tr.GetObject(ids[n], OpenMode.ForRead) as DBObject;
                            Polyline pline1 = obj as Polyline;
                            if (pline1 == null) return;
                            // Add the polyline to the List to rerase them all at the end of execution
                            delPline.Add(pline1);
                            // Add the polyline to the array
                            DBObjectCollection objArray1 = new DBObjectCollection();
                            objArray1.Add(pline1);
                            // create the 1 st region
                            DBObjectCollection objRegions1 = new DBObjectCollection();
                            objRegions1 = Region.CreateFromCurves(objArray1);
                            objreg1 = objRegions1[0] as Region;
                            btr.AppendEntity(objreg1);

                            tr.AddNewlyCreatedDBObject(objreg1, true);

                            objreg1.ColorIndex = 1;//optional
                            // add the region to the List<Region> for the future work
                            regLst.Add(objreg1);
                        }
                        //ed.WriteMessage("\nCount regions:\t{0}\n", regLst.Count);//just for the debug

                        // sort regions by areas
                        Region[] items = regLst.ToArray();
                        Array.Sort(items, (Region x, Region y) => y.Area.CompareTo(x.Area));
                        // get the biggest region first
                        Region mainReg = items[0];
                       // ed.WriteMessage("\nMain region area:\t{0:f3}\n", items[0].Area);//just for the debug
                        if (!mainReg.IsWriteEnabled) mainReg.UpgradeOpen();
                        if (items.Length == 2)
                        {

                            if (!doUnion)
                            {
                                mainReg.BooleanOperation(BooleanOperationType.BoolSubtract, (Region)items[1]);
                            }
                            else
                            {
                                mainReg.BooleanOperation(BooleanOperationType.BoolUnite, (Region)items[1]);
                            }
                        }
                        else
                        {
                            // starting iteration from the second region
                            int i = 1;
                            do
                            {
                                Region reg1 = items[i]; Region reg2 = items[i + 1];

                                if ((reg1 == null) || (reg2 == null))
                                {
                                    break;
                                }

                                else
                                {
                                    // subtract region 1 from region 2
                                    if (reg1.Area > reg2.Area)
                                    {
                                        // subtract the smaller region from the larger one
                                        //
                                        reg1.BooleanOperation(BooleanOperationType.BoolUnite, reg2);
                                        if (!doUnion)
                                        {
                                            mainReg.BooleanOperation(BooleanOperationType.BoolSubtract, reg1);
                                        }
                                        else
                                        {
                                            mainReg.BooleanOperation(BooleanOperationType.BoolUnite, reg1);
                                        }

                                    }

                                    else
                                    {

                                        // subtract the smaller region from the larger one

                                        reg2.BooleanOperation(BooleanOperationType.BoolUnite, reg1);
                                        if (!doUnion)
                                        {
                                            mainReg.BooleanOperation(BooleanOperationType.BoolSubtract, reg2);
                                        }
                                        else
                                        {
                                            mainReg.BooleanOperation(BooleanOperationType.BoolUnite, reg2);
                                        }
                                    }

                                }
                                // increase counter
                                i++;
                            } while (i < items.Length - 1);
                        }
                        mainReg.ColorIndex = 1;// put dummy color for region

                        // erase polylines
                        foreach (Polyline poly in delPline)
                        {
                            if (poly != null)
                            {
                                if (!poly.IsWriteEnabled) poly.UpgradeOpen();
                                poly.Erase();
                                if (!poly.IsDisposed) poly.Dispose();
                            }
                        }

                        //  ---    explode region and create polyline from exploded entities   ---   //

                        DBObjectCollection regexpl = new DBObjectCollection();
                        mainReg.Explode(regexpl);

                        List<ObjectId> exids = new List<ObjectId>();

                        // gather selected object into the List<ObjectId>
                        if (regexpl.Count > 0)
                        {
                            foreach (DBObject obj in regexpl)
                            {
                                Entity ent = obj as Entity;
                                if (ent != null)
                                {
                                    ObjectId eid = btr.AppendEntity(ent);
                                    tr.AddNewlyCreatedDBObject(ent, true);
                                   
                                    exids.Add(eid);
                                }
                            }
                        }
                        // define AcadDocument as object
                        object ActiveDocument = doc.AcadDocument;
                        ObjectId[] entids = new ObjectId[] { };
                        Array.Resize(ref entids, exids.Count);
                        // convert List<ObjectId> to array of ObjectID
                        exids.CopyTo(entids, 0);

                        ed.Regen();
                        // create a new selection set and exploded items
                        SelectionSet newset = SelectionSet.FromObjectIds(entids);

                        ed.SetImpliedSelection(newset.GetObjectIds());

                        PromptSelectionResult pfres = ed.SelectImplied();
                        // execute Sendcommand synchronously
                        ActiveDocument.GetType().InvokeMember(
                            "SendCommand", System.Reflection.BindingFlags.InvokeMethod, null, ActiveDocument,
                            new object[] { "select\n" });
                        // execute Sendcommand synchronously
                        string cmd = "_pedit _M _P" + " " + "" + " " + "_J" + " " + "" + " " + "" + "\n";
                        ActiveDocument.GetType().InvokeMember(
                            "SendCommand", System.Reflection.BindingFlags.InvokeMethod, null, ActiveDocument,
                            new object[] { cmd });
                        // rerase region if this is do not erased (relative to current DELOBJ variable value)
                        if (mainReg != null)
                            if (!mainReg.IsWriteEnabled)
                                mainReg.UpgradeOpen();
                        mainReg.Erase();
                       
                        tr.Commit();
                    }

                    catch (Autodesk.AutoCAD.Runtime.Exception ex)
                    {

                        ed.WriteMessage("\nAutoCAD exception:\n" + ex.Message + "\n" + ex.StackTrace);
                    }
                    finally
                    {
                        ed.WriteMessage("\n{0}", new Autodesk.AutoCAD.Runtime.ErrorStatus().ToString());//optional, might be removed
                    }
                }
            }
        }

43
External databases / Draw Polylines using Excel
« Last post by fixo on April 20, 2013, 08:28:38 PM »
Here is complete code, tested on AutoCAD 2010, Excel 2010:
Code: [Select]
Imports System.IO
Imports Microsoft.Office.Interop.Excel
Imports Autodesk.AutoCAD.Runtime
Imports Autodesk.AutoCAD.ApplicationServices
Imports Autodesk.AutoCAD.DatabaseServices
Imports Autodesk.AutoCAD.EditorInput
Imports Autodesk.AutoCAD.Geometry
Imports System.Runtime.InteropServices
Imports Excel = Microsoft.Office.Interop.Excel
'Imports MyProjectName.MyProjectName

<Assembly: CommandClass(GetType(MyProjectName.MyClassName))>
Namespace MyProjectName
    Public Class MyClassName

        <CommandMethod("hex")> _
        Public Sub ExcelToAcad()
            ReadExcelRange("C:\Test\TestXL.xlsx", "Sheet1")'<-- change file name and sheet name here
        End Sub

        Public Sub ReadExcelRange(ByVal xlFileName As String, ByVal xlSheetName As String)
            Dim lstPlines As New List(Of List(Of Object))
            If System.IO.File.Exists(xlFileName) Then

                Dim xlApp As Excel.Application = Nothing
                Dim xlWorkBooks As Excel.Workbooks = Nothing
                Dim xlWorkBook As Excel.Workbook = Nothing
                Dim xlWorkSheet As Excel.Worksheet = Nothing
                Dim xlWorkSheets As Excel.Sheets = Nothing
                Dim xlCells As Excel.Range = Nothing
                Dim xlRange As Excel.Range = Nothing

                xlApp = New Excel.Application
                Try
                    xlApp.DisplayAlerts = False
                    xlWorkBooks = xlApp.Workbooks
                    xlWorkBook = xlWorkBooks.Open(xlFileName)
                    xlApp.Visible = False
                    xlWorkSheets = xlWorkBook.Sheets
                    xlWorkSheet = CType(xlWorkSheets(xlSheetName), Excel.Worksheet)

                    xlRange = CType(xlWorkSheet.UsedRange.CurrentRegion, Excel.Range)


                    Dim xlRow As Excel.Range = Nothing
                    Dim xlCell As Excel.Range = Nothing

                    For irow As Integer = 1 To xlRange.Rows.Count

                        xlRow = CType(xlRange.Rows(irow), Excel.Range)
                        Dim lstRow As New List(Of Object)
                        For icol As Integer = 1 To xlRow.Cells.Count
                            xlCell = CType(xlRange.Cells(irow, icol), Excel.Range)
                            If xlCell.Value IsNot Nothing Then
                                lstRow.Add(xlCell.Value)
                            End If
                        Next

                        lstPlines.Add(lstRow)

                    Next
                    releaseObject(xlCell)
                    releaseObject(xlRow)
                    releaseObject(xlRange)

                    xlWorkBook.Close()

                    xlApp.Quit()

                    releaseObject(xlWorkSheets)
                    releaseObject(xlWorkSheet)
                    releaseObject(xlWorkBook)
                    releaseObject(xlWorkBooks)
                    releaseObject(xlApp)
                Catch ex As System.Exception

                    System.Windows.MessageBox.Show(ex.Message)

                End Try

                If lstPlines.Count > 0 Then
                    Dim doc As Document = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument
                    Dim ed As Editor = doc.Editor
                    Dim db As Database = doc.Database
                    Using tr As Transaction = db.TransactionManager.StartTransaction
                        Dim btr As BlockTableRecord = DirectCast(tr.GetObject(db.CurrentSpaceId, OpenMode.ForWrite), BlockTableRecord)

                        For Each lstCoords As List(Of Object) In lstPlines
                            Dim pline As New Polyline
                            Dim n As Integer = 0
                            Dim i As Integer = 0
                            For n = 0 To lstCoords.Count - 1 Step 2
                                Dim x As Double = Convert.ToDouble(lstCoords(n))
                                Dim y As Double = Convert.ToDouble(lstCoords(n + 1))

                                Dim pp As Point2d = New Point2d(x, y)
                                pline.AddVertexAt(i, pp, 0, 0, 0)
                                i += 1
                            Next
                            btr.AppendEntity(pline)
                            tr.AddNewlyCreatedDBObject(pline, True)
                        Next
                        tr.Commit()
                      System.Windows.MessageBox.Show("See result.")
                    End Using
                End If
            Else
                System.Windows.MessageBox.Show("'" & xlFileName & "' does not found.")
            End If
        End Sub
        Public Sub releaseObject(ByVal obj As Object)
            Try
                System.Runtime.InteropServices.Marshal.FinalReleaseComObject(obj)
                obj = Nothing
            Catch ex As System.Exception
                System.Diagnostics.Debug.Print(ex.ToString())
                obj = Nothing
            Finally
                GC.Collect()
            End Try
        End Sub
End Namespace

Please, see about Excel VB.NET for more :
http://www.siddharthrout.com/tag/vb-net-and-excel/
http://code.msdn.microsoft.com/Basics-of-using-Excel-4453945d
In the attached picture is data used for this code
44
This site / Re: Welcome on the AutoCAD .NET developpers forums
« Last post by skillpeak on April 15, 2013, 06:01:32 AM »
hi, this is skillpeak.
I am a beginner in autocad.
45
Events / Re: EventHandler for Entity Selection
« Last post by BlackBox on April 09, 2013, 09:18:35 PM »
I´m trying to get all entites (ids...) which are currently selected for displaying xdatas
in a palette.
If I select for example lines I want the ObjectIds saved in a Collection or array. If I unselect
the Entity/ies I want to remove the Id from the Collection.
If I run a command or something else, the Entites will be unselected too, but with the Method
ed.SelectionRemoved the entite Ids wont be removed / the event isnt fired.

And I dont want to run a command, this should be "interactive" like the autocad property palette...

This is an older thread, so not sure if you already got it sorted, but you might consider the Document.ImpliedSelectionChanged Event.
46
3D entities / Re: AutoCAD 2011 & VB.net Express 2008
« Last post by NirantarVidyarthee on April 04, 2013, 08:46:26 PM »
Thank you.

I'll try it and see if this works.
47
3D entities / Re: AutoCAD 2011 & VB.net Express 2008
« Last post by dockee on April 03, 2013, 07:40:12 PM »
I think the problem come from security framework.

See capsol command to make authorization on worker pc.

48
3D entities / Deployment - VB.Net Express 2008
« Last post by NirantarVidyarthee on April 02, 2013, 08:40:44 PM »
I have developed an Application using VB.Net Express 2008.

But I can't create a setup for this application. I use the publish command as suggested by Microsift. I am able to create a setup.exe but when I dblclick it it starts the application itself instead of asking where to install the application and then ends with an error.

Can any body please guide me the correct way to create the setup?

I can provide more information if you need.
49
3D entities / AutoCAD 2011 & VB.net Express 2008
« Last post by NirantarVidyarthee on April 02, 2013, 08:36:34 PM »
I have developed an pit-of-process Application using VB.Net Express 2008 and AutoCAD 2011. (These are User requirements and hence can't be changed).

The application developed runs on the development computer without any problem. But it does not run on the working computer. Details are as below:

Development PC is a single user stand-alone PC while working PC is a corporate network node. Operating systems, AutoCAD versions and system variables on both PCs match.

The application runs on development PC without any problems. However, on the working node it runs only through administrative access (login) but not with the user login.

Can any body please suggest me what needs to be done so that the program runs with user access (not Admin).

I can provide more details if you need.
50
Hatching / Re: Create associative hatch
« Last post by bcinnv on March 26, 2013, 01:21:28 PM »
Thanks fixo!  I'm tired of using the built in hatch functions... its automatic selection almost always crashes my session.
Pages: 1 ... 3 4 [5] 6 7 ... 10